﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Delivery.Invoice;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
        setting =>
        {

            setting.Name = "GridDeliveryInvoiceAndPay";
            setting.Width = Unit.Percentage(100);
            //setting.Height = Unit.Percentage(100);
            setting.Settings.ShowFilterRow = true;
            setting.Settings.ShowFilterRowMenu = true;
            setting.Settings.ShowColumnHeaders = true;
            //setting.KeyFieldName = "INVOICE_NO;INVOICE_DT;LP_CD;STATUS";
            setting.KeyFieldName = "DATA_KEY";

            setting.CallbackRouteValues = new { Controller = "D31405", Action = "PartialListData" };
            setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
            setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
            setting.ClientSideEvents.Init = "GridDeliveryInvoiceAndPay_Init";
            setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
            setting.SettingsBehavior.AllowSelectByRowClick = true;


            setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
            setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

            setting.SettingsPager.FirstPageButton.Visible = true;
            setting.SettingsPager.LastPageButton.Visible = true;
            setting.SettingsPager.ShowNumericButtons = true;
            //setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
            setting.SettingsPager.Position = PagerPosition.Bottom;
            setting.SettingsPager.PageSizeItemSettings.Visible = true;
            setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

            setting.CommandColumn.Visible = true;
            setting.CommandColumn.Width = Unit.Pixel(40);
            setting.CommandColumn.ClearFilterButton.Visible = true;
            setting.CommandColumn.ShowSelectCheckbox = true;

            setting.ClientSideEvents.SelectionChanged = "GridDeliveryInvoiceAndPay_SelectionChange";



            setting.CustomJSProperties = (s, e) =>
            {
                MVCxGridView grid = (MVCxGridView)s;
                //int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
                //int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
                
                int startIndex = 0;
                int endIndex = Model.GetModel<List<DeliveryInvoiceAndPaymentData>>().Count;
                //--=== List object
                //object[] STATUS = new object[endIndex - startIndex];
                object[] DATA_KEY = new object[endIndex - startIndex];
                object[] isSelected = new object[endIndex - startIndex];
                
                for (int n = startIndex; n < endIndex; n++)
                {
                    //STATUS[n - startIndex] = grid.GetRowValues(n, "STATUS");
                    DATA_KEY[n - startIndex] = grid.GetRowValues(n, "DATA_KEY");
                    isSelected[n - startIndex] = grid.Selection.IsRowSelected(n);
                }
                //e.Properties["cpSTATUS"] = STATUS;
                e.Properties["cpDATA_KEY"] = DATA_KEY;
                e.Properties["cpKeyField"] = grid.KeyFieldName;
                e.Properties["cpFocusedRowIndex"] = grid.FocusedRowIndex;
                e.Properties["cpIsRowSelected"] = isSelected;
                e.Properties["cpVisibleRow"] = grid.VisibleRowCount;

                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
                grid.JSProperties["cpStartIndex"] = startIndex;
                grid.JSProperties["cpEndIndex"] = endIndex;
            };

            if (setting.SettingsBehavior.AllowSelectSingleRowOnly == false)
            {
                setting.CommandColumn.SetHeaderTemplateContent(
                c =>
                {
                    Html.DevExpress().CheckBox(settingsCheckBox =>
                    {
                        settingsCheckBox.Name = "SelectAllCheckBox";
                        settingsCheckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                        settingsCheckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
                    }).Render();

                });
            }

            setting.Columns.Add(col =>
            {
                col.FieldName = "DATA_KEY";
                col.Caption = "Invoice No";
                col.Width = Unit.Pixel(100);
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                col.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkINV_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text.Substring(0, (content.Text.Length-1));
                            link.ClientVisible = true;
                            link.Width = 70;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnInvoiceNoClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });

            });

            setting.Columns.Add(
             col =>
             {
                 col.Caption = "Invoice Date";
                 col.Name = "INVOICE_DT";
                 col.FieldName = "INVOICE_DT";
                 //col.ColumnType = MVCxGridViewColumnType.DateEdit;
                 //col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                 col.ColumnType = MVCxGridViewColumnType.DateEdit;
                 col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                 var dateEditProperties = col.PropertiesEdit as DateEditProperties;
                 dateEditProperties.EditFormat = EditFormat.DateTime;
                 dateEditProperties.EditFormatString = "dd.MM.yyyy";
                 dateEditProperties.UseMaskBehavior = true;
                 col.Width = Unit.Pixel(90);
                 col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                 col.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
             });

            setting.Columns.Add(col =>
            {
                col.FieldName = "CURRENCY";
                col.Caption = "Currency";
                col.Width = Unit.Pixel(70);
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "TOTAL_AMOUNT";
                col.Caption = "Total Amount";
                col.Width = Unit.Pixel(100);
                col.PropertiesEdit.DisplayFormatString = "#,##0";
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "AMOUNT_BEFORE";
                col.Caption = "Amount<br>Before Tax";
                col.Width = Unit.Pixel(100);
                col.PropertiesEdit.DisplayFormatString = "#,##0";
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "TAX_AMOUNT";
                col.Caption = "Tax <br>Amount";
                col.Width = Unit.Pixel(100);
                col.PropertiesEdit.DisplayFormatString = "#,##0";
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.Add(col =>
            {
                col.FieldName = "STATUS";
                col.Caption = "Status";
                col.Width = Unit.Pixel(100);
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Payment";
                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Plan";
                            column.Name = "PLAN";
                            column.FieldName = "PLAN";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            column.Width = Unit.Pixel(90);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Equals;

                        }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Actual";
                            column.Name = "ACTUAL";
                            column.FieldName = "ACTUAL";
                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            column.Width = Unit.Pixel(90);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                        }
                        );

                }
            );

            setting.Columns.Add(col =>
            {
                col.FieldName = "PROGRESS_STATUS";
                col.Caption = "Progress <br>Status";
                col.Width = Unit.Pixel(100);

                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Created";
                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "By";
                            column.Name = "CREATED_BY";
                            column.FieldName = "CREATED_BY";
                            column.Width = Unit.Pixel(140);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        }
                        );

                    columnBand.Columns.Add(
                        column =>
                        {
                            column.Caption = "Date";
                            column.Name = "CREATED_DT";
                            column.FieldName = "CREATED_DT";

                            column.ColumnType = MVCxGridViewColumnType.DateEdit;
                            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;


                            column.Width = Unit.Pixel(120);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                        }
                        );

                });



            

            //-------- TOOGLE-----------------------------------
            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Submit";
                    columnBand.Name = "SUBMIT";
                    columnBand.Visible = false;
                    columnBand.Columns.Add(
                        RSH =>
                        {
                            RSH.Name = "SUBMIT_BY";
                            RSH.FieldName = "SUBMIT_BY";
                            RSH.Caption = "By";

                            RSH.Width = Unit.Pixel(140);
                            RSH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            RSH.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            RSH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            RSH.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                        });

                    columnBand.Columns.Add(
                        DPH =>
                        {
                            DPH.Name = "SUBMIT_DT";
                            DPH.FieldName = "SUBMIT_DT";
                            DPH.Caption = "Date";
                            DPH.ColumnType = MVCxGridViewColumnType.DateEdit;
                            DPH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = DPH.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;
                            DPH.Width = Unit.Pixel(120);
                            DPH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            DPH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            DPH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            DPH.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                        });

                });

            setting.Columns.AddBand(
                columnBand =>
                {
                    columnBand.Caption = "Posting";
                    columnBand.Visible = false;
                    columnBand.Name = "POSTING";
                    columnBand.Columns.Add(
                        shpr =>
                        {
                            shpr.Caption = "By";
                            shpr.Name = "POSTING_BY";
                            shpr.FieldName = "POSTING_BY";
                            shpr.Width = Unit.Pixel(140);
                            shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                            shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            shpr.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                        });


                    columnBand.Columns.Add(
                        dphpr =>
                        {
                            dphpr.Caption = "Date";
                            dphpr.Name = "POSTING_DT";
                            dphpr.FieldName = "POSTING_DT";

                            dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                            dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormat = EditFormat.DateTime;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;

                            dphpr.Width = Unit.Pixel(120);
                            dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            dphpr.Settings.AutoFilterCondition = AutoFilterCondition.Equals;

                        });

                    columnBand.Columns.Add(
                        pos =>
                        {
                            pos.Caption = "SAP Doc No";
                            pos.Name = "SAP_DOC_NO";
                            pos.FieldName = "SAP_DOC_NO";
                            pos.Width = Unit.Pixel(100);
                            pos.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            pos.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            pos.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            pos.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                        });

                });

            setting.Columns.Add(col =>
            {
                col.FieldName = "PAY_DOC_NO";
                col.Name = "PAY_DOC_NO";
                col.Caption = "Payment<br/>Doc No";
                col.Width = Unit.Pixel(100);
                col.Visible = false;
                col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.CellStyle.VerticalAlign = VerticalAlign.Middle;
                col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

            setting.Columns.AddBand(
            columnBand =>
            {
                columnBand.Caption = "Trucking";
                columnBand.Visible = false;
                columnBand.Name = "TRUCKING";
                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Code";
                        column.Name = "LP_CD";
                        column.FieldName = "LP_CD";
                        column.Width = Unit.Pixel(50);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                    }
                    );

                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Name";
                        column.Name = "LP_NAME";
                        column.FieldName = "LP_NAME";
                        column.Width = Unit.Pixel(250);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                    }
                    );

            });

        //}).Bind(Model.GetModel<DeliveryInvoiceAndPaymentModel>().DeliveryInvoiceAndPaymentListData).GetHtml()
        }).Bind(Model.GetModel<List<DeliveryInvoiceAndPaymentData>>()).GetHtml()
